''===============================================================================
''  ** IMPORTANT  **
''  Template: Miranda x Vb.Net x SqlServer
''  Version : 1.3
''  Author  : Gianluca Pezzoli
''  Entity  : CondizioneDiContoCorrente
''  Server  : 
''  DB      : Finanza
''  Table   : tblContiCorrentiCondizioni
''===============================================================================

'Imports System
'Imports System.ComponentModel
'Imports Pezzoli.Data.Miranda

'Namespace Titoli

'   <TableMapping("CondizioneDiContoCorrente", "tblContiCorrentiCondizioni")> _
'    Partial Public Class CondizioneDiContoCorrenteMsSql
'      Implements INotifyPropertyChanged, INotifyPropertyChanging

'      ' Enum with Entity Properties binded to DB Table columns
'      Public Enum LinkedProperties
'         IDContoCorrente
'         IDCondizione
'         IDTipoTitolo
'         Valore
'         Descrizione
'         ValidoDal
'         ValidoAl
'      End Enum

'      ' Private Table columns 
'      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
'      Private _IDContoCorrente As Short

'      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
'      Private _IDCondizione As Short

'      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
'      Private _IDTipoTitolo As Short

'      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
'      Private _Valore As String

'      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
'      Private _Descrizione As String

'      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
'      Private _ValidoDal As DateTime

'      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
'      Private _ValidoAl As DateTime



'      Private Sub SetDefaultValuesForBindedProperties()
'         _IDContoCorrente = 0
'         _IDCondizione = 0
'         _IDTipoTitolo = 0
'         _Valore = ""
'         _Descrizione = Nothing
'         _ValidoDal = Date.Now
'         _ValidoAl = DateSerial(2070, 12, 31)
'      End Sub

'      Public Sub New()
'         SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos
'      End Sub


'      '=================================================================
'      '  Properties Generated from the Table                        
'      '=================================================================
'#Region "Properties"

'      <ColumnMappingAttribute("IDContoCorrente", "SMALLINT", True, False, False, 0)> _
'      Public Property IDContoCorrente() As Short
'         Get
'            Return _IDContoCorrente
'         End Get
'         Set(ByVal Value As Short)
'            Try
'               _IDContoCorrente = Value
'               OnPropertyChanged("IDContoCorrente")
'            Catch ex As System.Exception
'               Throw New Exception("Error setting IDContoCorrente", ex)
'            End Try
'         End Set
'      End Property

'      <ColumnMappingAttribute("IDCondizione", "SMALLINT", True, False, False, 0)> _
'      Public Property IDCondizione() As Short
'         Get
'            Return _IDCondizione
'         End Get
'         Set(ByVal Value As Short)
'            Try
'               _IDCondizione = Value
'               OnPropertyChanged("IDCondizione")
'            Catch ex As System.Exception
'               Throw New Exception("Error setting IDCondizione", ex)
'            End Try
'         End Set
'      End Property

'      <ColumnMappingAttribute("IDTipoTitolo", "SMALLINT", True, False, False, 0)> _
'      Public Property IDTipoTitolo() As Short
'         Get
'            Return _IDTipoTitolo
'         End Get
'         Set(ByVal Value As Short)
'            Try
'               _IDTipoTitolo = Value
'               OnPropertyChanged("IDTipoTitolo")
'            Catch ex As System.Exception
'               Throw New Exception("Error setting IDTipoTitolo", ex)
'            End Try
'         End Set
'      End Property

'      <ColumnMappingAttribute("Valore", "VARCHAR", False, False, False, 30)> _
'      Public Property Valore() As String
'         Get
'            Return _Valore
'         End Get
'         Set(ByVal Value As String)
'            Try
'               If Value Is Nothing Then
'                  _Valore = Value
'                  OnPropertyChanged("Valore")
'               Else
'                  If Value.Length <= 30 Then
'                     _Valore = Value
'                     OnPropertyChanged("Valore")
'                  Else
'                     Throw New OverflowException("Error setting Valore, Length of Value is to long. Maximum Length: 30")
'                  End If
'               End If

'            Catch ex As System.Exception
'               Throw New Exception("Error setting Valore", ex)
'            End Try
'         End Set
'      End Property

'      <ColumnMappingAttribute("Descrizione", "VARCHAR", False, False, True, 50)> _
'      Public Property Descrizione() As String
'         Get
'            Return _Descrizione
'         End Get
'         Set(ByVal Value As String)
'            Try
'               If Value Is Nothing Then
'                  _Descrizione = Value
'                  OnPropertyChanged("Descrizione")
'               Else
'                  If Value.Length <= 50 Then
'                     _Descrizione = Value
'                     OnPropertyChanged("Descrizione")
'                  Else
'                     Throw New OverflowException("Error setting Descrizione, Length of Value is to long. Maximum Length: 50")
'                  End If
'               End If

'            Catch ex As System.Exception
'               Throw New Exception("Error setting Descrizione", ex)
'            End Try
'         End Set
'      End Property

'      <ColumnMappingAttribute("ValidoDal", "SMALLDATETIME", True, False, False, 0)> _
'      Public Property ValidoDal() As DateTime
'         Get
'            Return _ValidoDal
'         End Get
'         Set(ByVal Value As DateTime)
'            Try
'               _ValidoDal = Value
'               OnPropertyChanged("ValidoDal")
'            Catch ex As System.Exception
'               Throw New Exception("Error setting ValidoDal", ex)
'            End Try
'         End Set
'      End Property

'      <ColumnMappingAttribute("ValidoAl", "SMALLDATETIME", True, False, False, 0)> _
'      Public Property ValidoAl() As DateTime
'         Get
'            Return _ValidoAl
'         End Get
'         Set(ByVal Value As DateTime)
'            Try
'               _ValidoAl = Value
'               OnPropertyChanged("ValidoAl")
'            Catch ex As System.Exception
'               Throw New Exception("Error setting ValidoAl", ex)
'            End Try
'         End Set
'      End Property

'#End Region

'#Region "INotifyPropertyChanged"
'      Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

'      Protected Sub OnPropertyChanged(ByVal field As String)
'         RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(field))
'      End Sub
'#End Region

'#Region "INotifyPropertyChanging"
'      Public Event PropertyChanging(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangingEventArgs) Implements System.ComponentModel.INotifyPropertyChanging.PropertyChanging

'      Protected Sub OnPropertyChanging(ByVal field As String)
'         RaiseEvent PropertyChanging(Me, New PropertyChangingEventArgs(field))
'      End Sub
'#End Region
'   End Class
'End Namespace


'===============================================================================
'  ** IMPORTANT  **
'  Template: Miranda x Vb.Net x SqlServer
'  Version : 1.5
'  Author  : Gianluca Pezzoli
'  Entity  : Condizione
'  Server  : 
'  DB      : Finanza
'  Table   : tblContiCorrentiCondizioni
'  Generated by MyGeneration Version # (1.3.0.9)
'===============================================================================

Imports System
Imports System.ComponentModel
Imports Pezzoli.Data.Miranda

Namespace Titoli
  <TableMapping("CondizioneDiContoCorrente", "tblContiCorrentiCondizioni")> _
   Public Partial Class CondizioneDiContoCorrenteMsSql
      Implements INotifyPropertyChanged, INotifyPropertyChanging, IEditableObject, IEntity

      ' Enum with Entity Properties binded to DB Table columns
		Public Enum LinkedProperties
         IDContoCorrente
         IDCondizione
         IDTipoTitolo
         Valore
         Descrizione
         ValidoDal
         ValidoAl
		End Enum

      ' Private Table columns 
      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDContoCorrente As Short

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDCondizione As Short

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDTipoTitolo As Short

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Valore As String

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Descrizione As String

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _ValidoDal As DateTime

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _ValidoAl As DateTime

	 
    Private Sub SetDefaultValuesForBindedProperties() 
        _IDContoCorrente = 0
        _IDCondizione = 0
        _IDTipoTitolo = 0
        _Valore = ""
        _Descrizione = Nothing
        _ValidoDal = Date.Now
        _ValidoAl = DateSerial(2070,12,31)
	End Sub
	
   Public Sub New()		
		SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos
		
            _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty		
	End Sub

   Public Sub Reset()		
		' deve fare una Set dei default ma anche degli altri campi a null o al loro valore di default 'SetDefaultValuesForBindedProperties() ' Re-set defaults from DB Schema Infos
		SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos
		
        _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty
	End Sub
	
'|----------------------------------------------------------------|
'|             Properties Generated from the Table                |
'|________________________________________________________________|
#Region "Properties"
	
	<ColumnMappingAttribute("IDContoCorrente", "SMALLINT", True, False, False, 0)> _
	Public Property IDContoCorrente As Short
	   Get 
		  Return _IDContoCorrente
	   End Get
	   Set(ByVal Value as Short)
		  Try
           _IDContoCorrente = Value
           OnPropertyChanged("IDContoCorrente")
		  Catch ex As System.Exception
		     Throw New Exception("Error setting IDContoCorrente", ex)
		  End Try    
	   End Set
	End Property

	<ColumnMappingAttribute("IDCondizione", "SMALLINT", True, False, False, 0)> _
	Public Property IDCondizione As Short
	   Get 
		  Return _IDCondizione
	   End Get
	   Set(ByVal Value as Short)
		  Try
           _IDCondizione = Value
           OnPropertyChanged("IDCondizione")
		  Catch ex As System.Exception
		     Throw New Exception("Error setting IDCondizione", ex)
		  End Try    
	   End Set
	End Property

	<ColumnMappingAttribute("IDTipoTitolo", "SMALLINT", True, False, False, 0)> _
	Public Property IDTipoTitolo As Short
	   Get 
		  Return _IDTipoTitolo
	   End Get
	   Set(ByVal Value as Short)
		  Try
           _IDTipoTitolo = Value
           OnPropertyChanged("IDTipoTitolo")
		  Catch ex As System.Exception
		     Throw New Exception("Error setting IDTipoTitolo", ex)
		  End Try    
	   End Set
	End Property

	<ColumnMappingAttribute("Valore", "VARCHAR", False, False, False, 30)> _
	Public Property Valore As String
	   Get 
		  Return _Valore
	   End Get
	   Set(ByVal Value as String)
		  Try
			 If Value Is Nothing Then
			    _Valore = Value
				 OnPropertyChanged("Valore")
			 Else	 
			    If Value.Length <= 30 Then
			       _Valore = Value
				    OnPropertyChanged("Valore") 
			    Else
			       Throw New OverflowException("Error setting Valore, Length of Value is to long. Maximum Length: 30")
			    End If		 
			 End If
			  
		  Catch ex As System.Exception
		     Throw New Exception("Error setting Valore", ex)
		  End Try    
	   End Set
	End Property

	<ColumnMappingAttribute("Descrizione", "VARCHAR", False, False, True, 50)> _
	Public Property Descrizione As String
	   Get 
		  Return _Descrizione
	   End Get
	   Set(ByVal Value as String)
		  Try
			 If Value Is Nothing Then
			    _Descrizione = Value
				 OnPropertyChanged("Descrizione")
			 Else	 
			    If Value.Length <= 50 Then
			       _Descrizione = Value
				    OnPropertyChanged("Descrizione") 
			    Else
			       Throw New OverflowException("Error setting Descrizione, Length of Value is to long. Maximum Length: 50")
			    End If		 
			 End If
			  
		  Catch ex As System.Exception
		     Throw New Exception("Error setting Descrizione", ex)
		  End Try    
	   End Set
	End Property

	<ColumnMappingAttribute("ValidoDal", "SMALLDATETIME", True, False, False, 0)> _
	Public Property ValidoDal As DateTime
	   Get 
		  Return _ValidoDal
	   End Get
	   Set(ByVal Value as DateTime)
		  Try
           _ValidoDal = Value
           OnPropertyChanged("ValidoDal")
		  Catch ex As System.Exception
		     Throw New Exception("Error setting ValidoDal", ex)
		  End Try    
	   End Set
	End Property

	<ColumnMappingAttribute("ValidoAl", "SMALLDATETIME", True, False, False, 0)> _
	Public Property ValidoAl As DateTime
	   Get 
		  Return _ValidoAl
	   End Get
	   Set(ByVal Value as DateTime)
		  Try
           _ValidoAl = Value
           OnPropertyChanged("ValidoAl")
		  Catch ex As System.Exception
		     Throw New Exception("Error setting ValidoAl", ex)
		  End Try    
	   End Set
	End Property
#End Region
	  
#Region "INotifyPropertyChanged"
      Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged
	  
      Protected Sub OnPropertyChanged(ByVal field As String)
         RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(field))
      End Sub
#End Region

#Region "INotifyPropertyChanging"
      Public Event PropertyChanging(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangingEventArgs) Implements System.ComponentModel.INotifyPropertyChanging.PropertyChanging
      
      Protected Sub OnPropertyChanging(ByVal field As String)
         RaiseEvent PropertyChanging(Me, New PropertyChangingEventArgs(field))
      End Sub
#End Region	

#Region "IEditableObject"
      'Private _Editing as Boolean
	  'Private _New As Boolean
	  'Private _Parent As ....
      Private _Status As EntityStatus
      Private _PreviousStatus As EntityStatus	  
		
      ' Private Table columns Old Values
      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _OldIDContoCorrente As Short

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _OldIDCondizione As Short

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _OldIDTipoTitolo As Short

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _OldValore As String

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _OldDescrizione As String

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _OldValidoDal As DateTime

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _OldValidoAl As DateTime
		 
'   Friend Sub SetParent(ByVal parent As ...)
'      _Parent = parent
'   End Sub

    Public Sub BeginEdit() Implements System.ComponentModel.IEditableObject.BeginEdit
	   'If Not _Editing Then 
	   If _Status = EntityStatus.Empty Or _Status = EntityStatus.Loaded Then 
          _OldIDContoCorrente = _IDContoCorrente
          _OldIDCondizione = _IDCondizione
          _OldIDTipoTitolo = _IDTipoTitolo
          _OldValore = _Valore
          _OldDescrizione = _Descrizione
          _OldValidoDal = _ValidoDal
          _OldValidoAl = _ValidoAl		 
		  '_Editing = True
          _PreviousStatus = _Status
          _Status = EntityStatus.Editing

          If _PreviousStatus = EntityStatus.Empty Then
             RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyNew))
          End If
          If _PreviousStatus = EntityStatus.Loaded Then
             RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
          End If		   
	   End If
    End Sub
	 
   Public Sub CancelEdit() Implements System.ComponentModel.IEditableObject.CancelEdit
      'If _New Then
      If _Status = EntityStatus.Empty Then	  
           '_Parent.Remove(Me)
      Else 
         If _IDContoCorrente <> _OldIDContoCorrente Then
            _IDContoCorrente = _OldIDContoCorrente
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("IDContoCorrente"))
         End If
         If _IDCondizione <> _OldIDCondizione Then
            _IDCondizione = _OldIDCondizione
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("IDCondizione"))
         End If
         If _IDTipoTitolo <> _OldIDTipoTitolo Then
            _IDTipoTitolo = _OldIDTipoTitolo
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("IDTipoTitolo"))
         End If
         If _Valore <> _OldValore Then
            _Valore = _OldValore
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Valore"))
         End If
         If _Descrizione <> _OldDescrizione Then
            _Descrizione = _OldDescrizione
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Descrizione"))
         End If
         If _ValidoDal <> _OldValidoDal Then
            _ValidoDal = _OldValidoDal
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("ValidoDal"))
         End If
         If _ValidoAl <> _OldValidoAl Then
            _ValidoAl = _OldValidoAl
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("ValidoAl"))
         End If	
		 
	      If _PreviousStatus = EntityStatus.Empty Then
             _Status = EntityStatus.Empty
             RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditNew))
          Else
             _Status = EntityStatus.Loaded
             RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditLoaded))
          End If
	   End If
		'_Editing = False
	End Sub
	
    Public Sub EndEdit() Implements System.ComponentModel.IEditableObject.EndEdit
       '_Editing = False
       '_New = False
       _PreviousStatus = _Status
       _Status = EntityStatus.Loaded
       'RaiseEvent EntityChanged(Me, System.EventArgs.Empty)
       If _PreviousStatus = EntityStatus.Loaded Then
           RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditLoaded))
       Else
           RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditNew))
       End If	   
    End Sub	
#End Region

#Region "IEntity"
    Public Event EntityChanged(ByVal sender As Object, ByVal e As EntityActionEventArgs) Implements Pezzoli.Data.Miranda.IEntity.EntityChanged

    Public Sub SetStatus(ByVal newStatus As Pezzoli.Data.Miranda.EntityStatus) Implements Pezzoli.Data.Miranda.IEntity.SetStatus
        _PreviousStatus = _Status
        _Status = newStatus
        'RaiseEvent EntityChanged(Me, New EntityActionEventArgs())
        Select _Status
            Case EntityStatus.Editing
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
            Case EntityStatus.Empty
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Create))
            Case EntityStatus.Loaded
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Load))
        End Select
    End Sub

    Public ReadOnly Property Status As Pezzoli.Data.Miranda.EntityStatus Implements Pezzoli.Data.Miranda.IEntity.Status
        Get
            Return _Status
        End Get
    End Property
#End Region
 End Class
 
End NameSpace 
